/*
 * Multi precision toolbox for Scilab
 * Copyright (C) 2009 - Jonathan Blanchard
 *
 * This file must be used under the terms of the CeCILL.
 * This source file is licensed as described in the file COPYING, which
 * you should have received as part of this distribution.  The terms
 * are also available at
 * http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
 */

#include "mpscilab_config.h"
#include "mps.h"

/* memoryfuncs.c functions. */
int MpsCreateVarFrom( int, mps_t, int * );
mps_ptr MpsGetMatrix( int );
mps_ptr MpsGetMatrixFromAddr( int * );
int MpsCollect();

/* argscheck.c functions. */
int MpsCheck1( char*, int*, int*, int*, int* );
int MpsCheck2( char*, int*, int*, int* );
int MpsCheck3( char*, int*, int*, int* );
int MpsCheckSameSize( char*, int*, int*, int*, int* );
int MpsCheckSameSize2( char*, int*, int*, int* );
int MpsCheckAllSameMps( char *, int*, int*, int*, int* );
int MpsCheckStringSize( char*, int*, int, unsigned int, unsigned int );
int MpsCheckSize( char*, int*, int, unsigned int, unsigned int );
int MpsCheckScalar( char*, int*, int );
int MpsIsValid( char*, int *, int );
int MpsGetRoundingArg( char*, mp_rnd_t*, int*, int );

int sci_mps_init1( char*, unsigned long );
int sci_mps_init2( char*, unsigned long );
int sci_mps_clear( char*, unsigned long );
int sci_mps_disp( char*, unsigned long );

int sci_mps_add( char*, unsigned long );
int sci_mps_mul( char*, unsigned long );
int sci_mps_mat_mul( char*, unsigned long );

/* sci_mps_trig.c functions. */
int sci_mps_sin( char*, unsigned long );
int sci_mps_cos( char*, unsigned long );
int sci_mps_tan( char*, unsigned long );
int sci_mps_sec( char*, unsigned long );
int sci_mps_csc( char*, unsigned long );
int sci_mps_cot( char*, unsigned long );
int sci_mps_asin( char*, unsigned long );
int sci_mps_acos( char*, unsigned long );
int sci_mps_atan( char*, unsigned long );

int sci_mps_sinh( char*, unsigned long );
int sci_mps_cosh( char*, unsigned long );
int sci_mps_tanh( char*, unsigned long );
int sci_mps_sech( char*, unsigned long );
int sci_mps_csch( char*, unsigned long );
int sci_mps_coth( char*, unsigned long );
int sci_mps_asinh( char*, unsigned long );
int sci_mps_acosh( char*, unsigned long );
int sci_mps_atanh( char*, unsigned long );

/* sci_mps_lu.c */
int sci_mps_lu( char*, unsigned long );
